前往小程序,Get更优阅读体验!
立即前往
首页
学习
活动
专区
工具
TVP
发布
社区首页 >专栏 >【LeetCode】724. Find Pivot Index

【LeetCode】724. Find Pivot Index

作者头像
韩旭051
发布2019-12-03 15:30:20
3750
发布2019-12-03 15:30:20
举报
文章被收录于专栏:刷题笔记刷题笔记

版权声明:本文为博主原创文章,遵循 CC 4.0 BY 版权协议,转载请附上原文出处链接和本声明。

本文链接:https://blog.csdn.net/shiliang97/article/details/103180681

Given an array of integers nums, write a method that returns the "pivot" index of this array.

We define the pivot index as the index where the sum of the numbers to the left of the index is equal to the sum of the numbers to the right of the index.

If no such index exists, we should return -1. If there are multiple pivot indexes, you should return the left-most pivot index.

Example 1:

Input: nums = [1, 7, 3, 6, 5, 6] Output: 3 Explanation: The sum of the numbers to the left of index 3 (nums[3] = 6) is equal to the sum of numbers to the right of index 3. Also, 3 is the first index where this occurs.

Example 2:

Input: nums = [1, 2, 3] Output: -1 Explanation: There is no index that satisfies the conditions in the problem statement.

Note:

The length of nums will be in the range [0, 10000]. Each element nums[i] will be an integer in the range [-1000, 1000].

来源:力扣(LeetCode) 链接:https://leetcode-cn.com/problems/find-pivot-index 著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。

特别简单的题,可能是我心态不太好,没有读懂题,做的时候思路也不是很好,。。。。

直接放答案,这个思路一看就出来了

代码语言:javascript
复制
class Solution {
public:
    int pivotIndex(vector<int>& nums) {
        int sum = 0, leftsum = 0;
        for (int x: nums) sum += x;
        for (int i = 0; i < nums.size(); ++i) {
            if (leftsum == sum - leftsum - nums[i]) return i;
            leftsum += nums[i];
        }
        return -1;
    }
};

再说下我最开始的思路,想的是双指针,两头碰,两个下标,那边和小了,那个往中间动,但是没有考虑到,可能都是负数的情况,越移动越小,所以这种思路是错误的~~~~。还是长见识了,多熟悉一些常用的方法就好了吧~

本文参与 腾讯云自媒体分享计划,分享自作者个人站点/博客。
原始发表:2019-11-21 ,如有侵权请联系 cloudcommunity@tencent.com 删除

本文分享自 作者个人站点/博客 前往查看

如有侵权,请联系 cloudcommunity@tencent.com 删除。

本文参与 腾讯云自媒体分享计划  ,欢迎热爱写作的你一起参与!

评论
登录后参与评论
0 条评论
热度
最新
推荐阅读
目录
  • 特别简单的题,可能是我心态不太好,没有读懂题,做的时候思路也不是很好,。。。。
  • 再说下我最开始的思路,想的是双指针,两头碰,两个下标,那边和小了,那个往中间动,但是没有考虑到,可能都是负数的情况,越移动越小,所以这种思路是错误的~~~~。还是长见识了,多熟悉一些常用的方法就好了吧~
领券
问题归档专栏文章快讯文章归档关键词归档开发者手册归档开发者手册 Section 归档